OpenTTD: src/command_func.h File Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- File List
- Globals

Macros | Functions | Variables
command_func.h File Reference

Functions related to commands. More...

`#include "command_type.h"`
`#include "company_type.h"`

Go to the source code of this file.

## Macros
#define | return_cmd_error(errcode) return CommandCost(errcode);
| Returns from a function with a specific StringID as error.

## Functions
CommandCost | DoCommand (TileIndex tile, uint32 p1, uint32 p2, DoCommandFlag flags, uint32 cmd, const char *text=NULL)
CommandCost | DoCommand (const CommandContainer *container, DoCommandFlag flags)
| Shorthand for calling the long DoCommand with a container.
bool | DoCommandP (TileIndex tile, uint32 p1, uint32 p2, uint32 cmd, CommandCallback *callback=NULL, const char *text=NULL, bool my_cmd=true)
bool | DoCommandP (const CommandContainer *container, bool my_cmd=true)
| Shortcut for the long DoCommandP when having a container with the data.
CommandCost | DoCommandPInternal (TileIndex tile, uint32 p1, uint32 p2, uint32 cmd, CommandCallback *callback, const char *text, bool my_cmd, bool estimate_only)
void | NetworkSendCommand (TileIndex tile, uint32 p1, uint32 p2, uint32 cmd, CommandCallback *callback, const char *text, CompanyID company)
| Prepare a DoCommand to be send over the network.
bool | IsValidCommand (uint32 cmd)
CommandFlags | GetCommandFlags (uint32 cmd)
const char * | GetCommandName (uint32 cmd)
Money | GetAvailableMoneyForCommand ()
bool | IsCommandAllowedWhilePaused (uint32 cmd)
| Returns whether the command is allowed while the game is paused.
static DoCommandFlag | CommandFlagsToDCFlags (CommandFlags cmd_flags)
| Extracts the DC flags needed for DoCommand from the flags returned by GetCommandFlags.

## Variables
static const CommandCost | CMD_ERROR = CommandCost(INVALID_STRING_ID)
| Define a default return value for a failed command.
Money | _additional_cash_required
CommandCallback | CcAI
CommandCallback | CcBuildAirport
CommandCallback | CcBuildBridge
CommandCallback | CcBuildDocks
CommandCallback | CcBuildCanal
CommandCallback | CcCloneVehicle
CommandCallback | CcGame
CommandCallback | CcCreateGroup
CommandCallback | CcAddVehicleNewGroup
CommandCallback | CcBuildIndustry
CommandCallback | CcPlaySound10
CommandCallback | CcPlaceSign
CommandCallback | CcTerraform
CommandCallback | CcGiveMoney
CommandCallback | CcPlaySound1E
CommandCallback | CcRailDepot
CommandCallback | CcStation
CommandCallback | CcBuildRailTunnel
CommandCallback | CcPlaySound1D
CommandCallback | CcBuildRoadTunnel
CommandCallback | CcRoadDepot
CommandCallback | CcRoadStop
CommandCallback | CcBuildWagon
CommandCallback | CcFoundTown
CommandCallback | CcFoundRandomTown
CommandCallback | CcBuildPrimaryVehicle
CommandCallback | CcStartStopVehicle

## Detailed Description

Functions related to commands.

Definition in file command_func.h.

## Macro Definition Documentation

#define return_cmd_error | ( |  | errcode | ) | return CommandCost(errcode);

Returns from a function with a specific StringID as error.

This macro is used to return from a function. The parameter contains the StringID which will be returned.

Parameters

  errcode | The StringID to return

Definition at line 35 of file command_func.h.

Referenced by BuildStationPart(), CanExpandRailStation(), CheckAllowRemoveRoad(), CheckBridgeAvailability(), CheckBuildableTile(), CheckFlatLandRailStation(), CheckFlatLandRoadStop(), CheckforTownRating(), CheckIfAuthorityAllowsNewStation(), CheckIfFarEnoughFromConflictingIndustry(), CheckIfIndustryIsAllowed(), CheckIfIndustryTilesAreFree(), CheckNewIndustry_BubbleGen(), CheckNewIndustry_Farm(), CheckNewIndustry_Forest(), CheckNewIndustry_Lumbermill(), CheckNewIndustry_OilRefinery(), CheckNewIndustry_OilRig(), CheckNewIndustry_Plantation(), CheckNewIndustry_Water(), CheckNewTrain(), CheckOwnership(), CheckRailSlope(), CheckTileOwnership(), CheckTrackCombination(), CheckTrainAttachment(), ClearTile_Station(), ClearTile_TunnelBridge(), CmdAlterGroup(), CmdBuildAirport(), CmdBuildBridge(), CmdBuildBuoy(), CmdBuildCanal(), CmdBuildDock(), CmdBuildLock(), CmdBuildObject(), CmdBuildRailStation(), CmdBuildRailWaypoint(), CmdBuildRoad(), CmdBuildRoadDepot(), CmdBuildRoadStop(), CmdBuildRoadVehicle(), CmdBuildShipDepot(), CmdBuildSingleRail(), CmdBuildSingleSignal(), CmdBuildTrainDepot(), CmdBuildTunnel(), CmdBuildVehicle(), CmdBuyShareInCompany(), CmdChangeTimetable(), CmdCloneOrder(), CmdCloneVehicle(), CmdDecreaseLoan(), CmdFoundTown(), CmdIncreaseLoan(), CmdInsertOrder(), CmdLandscapeClear(), CmdLevelLand(), CmdMoveRailVehicle(), CmdPlaceSign(), CmdPlantTree(), CmdRefitVehicle(), CmdRemoveRoadStop(), CmdRemoveSingleRail(), CmdRemoveSingleSignal(), CmdRenameCompany(), CmdRenameDepot(), CmdRenameEngine(), CmdRenamePresident(), CmdRenameStation(), CmdRenameTown(), CmdRenameVehicle(), CmdRenameWaypoint(), CmdReverseTrainDirection(), CmdSellRailWagon(), CmdSellVehicle(), CmdSignalTrackHelper(), CmdStartStopVehicle(), CmdTerraformLand(), CreateNewIndustryHelper(), DoBuildLock(), EnsureNoTrainOnTrackBits(), EnsureNoVehicleOnGround(), FindJoiningBaseStation(), FindTownForIndustry(), GetStationAround(), IsValidTileForWaypoint(), PerformIndustryTileSlopeCheck(), RemoveBuoy(), RemoveRoad(), Vehicle::SendToDepot(), TerraformTileHeight(), TestAutoslopeOnRailTile(), TownActionBuildStatue(), TownCanBePlacedHere(), and TunnelBridgeIsFree().

## Function Documentation

static DoCommandFlag CommandFlagsToDCFlags | ( | CommandFlags | cmd_flags | ) |
| inlinestatic

Extracts the DC flags needed for DoCommand from the flags returned by GetCommandFlags.

Parameters

  cmd_flags | Flags from GetCommandFlags

Returns
  flags for DoCommand

Definition at line 62 of file command_func.h.

References CMD_ALL_TILES, CMD_AUTO, CMD_NO_WATER, DC_ALL_TILES, DC_AUTO, DC_NO_WATER, and DC_NONE.

Referenced by DoCommandPInternal(), GrowTownWithBridge(), ShowBuildBridgeWindow(), and StationJoinerNeeded().

CommandCost DoCommand | ( | TileIndex | tile,
|  | uint32 | p1,
|  | uint32 | p2,
|  | DoCommandFlag | flags,
|  | uint32 | cmd,
|  | const char * | text
| ) |  |

This function executes a given command with the parameters from the CommandProc parameter list. Depending on the flags parameter it execute or test a command.

Parameters

  tile | The tile to apply the command on (for the CommandProc)
  p1 | Additional data for the command (for the CommandProc)
  p2 | Additional data for the command (for the CommandProc)
  flags | Flags for the command and how to execute the command
  cmd | The command-id to execute (a value of the CMD_* enums)
  text | The text to pass

See Also
  CommandProc

Returns
  the cost

Definition at line 454 of file command.cpp.

References CheckCompanyHasMoney(), CMD_ERROR, CMD_ID_MASK, DC_ALL_TILES, DC_BANKRUPT, DC_EXEC, DC_QUERY_COST, error(), CommandCost::Failed(), IsValidTile(), MapSize(), Command::proc, SetTownRatingTestMode(), and SubtractMoneyFromCompany().

CommandCost DoCommand | ( | const CommandContainer * | container,
|  | DoCommandFlag | flags
| ) |  |

Shorthand for calling the long DoCommand with a container.

Parameters

  container | Container with (almost) all information
  flags | Flags for the command and how to execute the command

See Also
  CommandProc

Returns
  the cost

Definition at line 436 of file command.cpp.

References CommandContainer::cmd, CMD_ID_MASK, DoCommand(), CommandContainer::p1, CommandContainer::p2, CommandContainer::text, and CommandContainer::tile.

Referenced by BuildReplacementVehicle(), CanBuildHouseHere(), CanBuildTramTrackOnTile(), ChangeOwnershipOfCompanyItems(), CheckFlatLand(), CheckFlatLandRailStation(), CheckFlatLandRoadStop(), CheckIfCanLevelIndustryPlatform(), CheckIfIndustryTilesAreFree(), ClearMakeHouseTile(), CmdAddSharedVehicleGroup(), CmdBuildBridge(), CmdBuildBuoy(), CmdBuildCanal(), CmdBuildDock(), CmdBuildLongRoad(), CmdBuildObject(), CmdBuildRailWagon(), CmdBuildRoad(), CmdBuildRoadDepot(), CmdBuildShipDepot(), CmdBuildSingleRail(), CmdBuildTrainDepot(), CmdBuildTunnel(), CmdClearArea(), CmdCloneVehicle(), CmdDeleteGroup(), CmdDeleteTown(), CmdDepotMassAutoReplace(), CmdDepotSellAllVehicles(), CmdLevelLand(), CmdMassStartStopVehicle(), CmdMoveVehicle(), CmdPlantTree(), CmdRailTrackHelper(), CmdRemoveAllVehiclesGroup(), CmdRemoveLongRoad(), CmdRemoveSingleRail(), CmdRenamePresident(), CmdSignalTrackHelper(), CmdStartStopVehicle(), CmdTerraformLand(), CopyHeadSpecificThings(), DoBuildLock(), DoCommand(), DoCreateNewIndustry(), DoDryUp(), DoFloodTile(), OrderBackup::DoRestore(), FloodHalftile(), RefitWindow::GetCapacityString(), GrowTown(), GrowTownWithBridge(), GrowTownWithRoad(), HandleStationRefit(), IsRoadAllowedHere(), NormalizeTrainVehInDepot(), LandInfoWindow::OnInit(), BuildRoadToolbarWindow::OnPlacePresize(), BuildRailToolbarWindow::OnPlacePresize(), RemoveRailStation(), RemoveRailWaypoint(), RemoveRoad(), ReplaceChain(), ReplaceFreeUnit(), ResetLandscapeConfirmationCallback(), SearchLumberMillTrees(), SendAllVehiclesToDepot(), Vehicle::SendToDepot(), ShowBuildBridgeWindow(), ShowNewGrfVehicleError(), StationJoinerNeeded(), TownActionBuildStatue(), TryClearTile(), UpdateOrderDest(), and VehicleEnterDepot().

bool DoCommandP | ( | TileIndex | tile,
|  | uint32 | p1,
|  | uint32 | p2,
|  | uint32 | cmd,
|  | CommandCallback * | callback,
|  | const char * | text,
|  | bool | my_cmd
| ) |  |

Toplevel network safe docommand function for the current company. Must not be called recursively. The callback is called when the command succeeded or failed. The parameters tile, p1, and p2 are from the CommandProc function. The parameter cmd is the command to execute. The parameter my_cmd is used to indicate if the command is from a company or the server.

Parameters

  tile | The tile to perform a command on (see CommandProc)
  p1 | Additional data for the command (see CommandProc)
  p2 | Additional data for the command (see CommandProc)
  cmd | The command to execute (a CMD_* value)
  callback | A callback function to call after the command is finished
  text | The text to pass
  my_cmd | indicator if the command is from a company or server (to display error messages for a user)

Returns
  `true` if the command succeeded, else `false`.

Definition at line 547 of file command.cpp.

References _generating_world, _networking, _pause_mode, _shift_pressed, CLIENT_ID_SERVER, CMD_CLIENT_ID, CMD_ID_MASK, CMD_NETWORK_COMMAND, CMD_PAUSE, DoCommandPInternal(), CommandCost::Failed(), GB(), GetCommandFlags(), CommandCost::GetCost(), CommandCost::GetErrorMessage(), CommandCost::GetTextRefStack(), CommandCost::GetTextRefStackGRF(), CommandCost::GetTextRefStackSize(), IsCommandAllowedWhilePaused(), IsLocalCompany(), PM_UNPAUSED, ShowCostOrIncomeAnimation(), ShowErrorMessage(), ShowEstimatedCostOrIncome(), CommandCost::Succeeded(), TILE_SIZE, TileX(), TileY(), and WL_INFO.

bool DoCommandP | ( | const CommandContainer * | container,
|  | bool | my_cmd
| ) |  |

Shortcut for the long DoCommandP when having a container with the data.

Parameters

  container | the container with information.
  my_cmd | indicator if the command is from a company or server (to display error messages for a user)

Returns
  true if the command succeeded, else false

Definition at line 527 of file command.cpp.

References CommandContainer::callback, CommandContainer::cmd, DoCommandP(), CommandContainer::p1, CommandContainer::p2, CommandContainer::text, and CommandContainer::tile.

Referenced by AskUnsafeUnpauseCallback(), CcBuildWagon(), ChangeTimetableStartCallback(), CheckPauseHelper(), CheckTrainsLengths(), ClickMoneyCheat(), CommonRaiseLowerBigLand(), CompanyCheckBankrupt(), ConnectRoadToStructure(), DoCommandP(), GenerateDesertArea(), GenericPlaceSignals(), GUIPlaceProcDragXY(), HandleAutoSignalPlacement(), MaybeStartNewCompany(), MenuClickCompany(), NetworkAutoCleanCompanies(), NetworkExecuteLocalCommandQueue(), EnginePreviewWindow::OnClick(), TownAuthorityWindow::OnClick(), GoalQuestionWindow::OnClick(), TownViewWindow::OnClick(), CompanyFinancesWindow::OnClick(), ReplaceVehicleWindow::OnClick(), BuildIndustryWindow::OnClick(), TimetableWindow::OnClick(), VehicleGroupWindow::OnClick(), DepotWindow::OnClick(), SelectCompanyLiveryWindow::OnClick(), RefitWindow::OnClick(), OrdersWindow::OnClick(), AIDebugWindow::OnClick(), BuildVehicleWindow::OnClick(), SelectCompanyManagerFaceWindow::OnClick(), VehicleListWindow::OnClick(), StationViewWindow::OnClick(), VehicleDetailsWindow::OnClick(), CompanyWindow::OnClick(), SelectStationWindow< T >::OnClick(), BuyCompanyWindow::OnClick(), VehicleViewWindow::OnClick(), DepotWindow::OnDragDrop(), OrdersWindow::OnDragDrop(), VehicleGroupWindow::OnDropdownSelect(), SelectCompanyLiveryWindow::OnDropdownSelect(), OrdersWindow::OnDropdownSelect(), VehicleListWindow::OnDropdownSelect(), VehicleDetailsWindow::OnDropdownSelect(), MainWindow::OnHotkey(), AIDebugWindow::OnInvalidateData(), BuildTreesWindow::OnPlaceMouseUp(), BuildDocksToolbarWindow::OnPlaceMouseUp(), BuildRoadToolbarWindow::OnPlaceMouseUp(), BuildRailToolbarWindow::OnPlaceMouseUp(), BuildDocksToolbarWindow::OnPlaceObject(), TerraformToolbarWindow::OnPlaceObject(), BuildRoadToolbarWindow::OnPlaceObject(), BuildIndustryWindow::OnPlaceObject(), BuildRailToolbarWindow::OnPlaceObject(), OrdersWindow::OnPlaceObject(), CompanyWindow::OnPlaceObject(), WaypointWindow::OnQueryTextFinished(), TownViewWindow::OnQueryTextFinished(), TimetableWindow::OnQueryTextFinished(), VehicleGroupWindow::OnQueryTextFinished(), DepotWindow::OnQueryTextFinished(), OrdersWindow::OnQueryTextFinished(), BuildVehicleWindow::OnQueryTextFinished(), StationViewWindow::OnQueryTextFinished(), VehicleDetailsWindow::OnQueryTextFinished(), CompanyWindow::OnQueryTextFinished(), DepotWindow::OnVehicleSelect(), OrdersWindow::OrderClick_Delete(), OrdersWindow::OrderClick_FullLoad(), OrdersWindow::OrderClick_NearestDepot(), OrdersWindow::OrderClick_Nonstop(), OrdersWindow::OrderClick_Refit(), OrdersWindow::OrderClick_Service(), OrdersWindow::OrderClick_Skip(), OrdersWindow::OrderClick_StopSharing(), OrdersWindow::OrderClick_Unload(), PlaceExtraDepotRail(), PlaceProc_Object(), PlaceProc_Sign(), PlaceRail_Waypoint(), RenameSign(), ReplaceVehicleWindow::ReplaceClick_StartReplace(), OrderBackup::ResetUser(), SetCompanySetting(), SetSettingValue(), ShowBuildBridgeWindow(), ShowSelectBaseStationIfNeeded(), and StartStopVehicle().

CommandCost DoCommandPInternal | ( | TileIndex | tile,
|  | uint32 | p1,
|  | uint32 | p2,
|  | uint32 | cmd,
|  | CommandCallback * | callback,
|  | const char * | text,
|  | bool | my_cmd,
|  | bool | estimate_only
| ) |  |

Helper function for the toplevel network safe docommand function for the current company.

Parameters

  tile | The tile to perform a command on (see CommandProc)
  p1 | Additional data for the command (see CommandProc)
  p2 | Additional data for the command (see CommandProc)
  cmd | The command to execute (a CMD_* value)
  callback | A callback function to call after the command is finished
  text | The text to pass
  my_cmd | indicator if the command is from a company or server (to display error messages for a user)
  estimate_only | whether to give only the estimate or also execute the command

Returns
  the command cost of this function.

Definition at line 623 of file command.cpp.

References _current_company, _date, _date_fract, _generating_world, _local_company, _networking, Backup< T >::Change(), CheckCompanyHasMoney(), CMD_ALL_TILES, CMD_CLIENT_ID, CMD_COMPANY_CTRL, CMD_DEITY, CMD_ERROR, CMD_FLAGS_MASK, CMD_ID_MASK, CMD_NETWORK_COMMAND, CMD_NO_TEST, CMD_SERVER, CMD_SPECTATOR, CommandFlagsToDCFlags(), COMPANY_SPECTATOR, DC_EXEC, DEBUG, CommandCost::Failed(), GetCommandFlags(), GetCommandName(), CommandCost::GetCost(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::GetIfValid(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), IsValidTile(), CompanyProperties::last_build_coordinate, lengthof, MapSize(), NetworkSendCommand(), OWNER_DEITY, Command::proc, PSM_ENTER_COMMAND, PSM_ENTER_TESTMODE, PSM_LEAVE_COMMAND, PSM_LEAVE_TESTMODE, Backup< T >::Restore(), return_dcpi, SetDParam(), SetTownRatingTestMode(), SubtractMoneyFromCompany(), BasePersistentStorageArray::SwitchMode(), Backup< T >::Trash(), UpdateSignalsInBuffer(), and Backup< T >::Verify().

Referenced by DoCommandP(), and OrderBackup::Reset().

Money GetAvailableMoneyForCommand | ( |  | ) |

This functions returns the money which can be used to execute a command. This is either the money of the current company or INT64_MAX if there is no such a company "at the moment" like the server itself.

Returns
  The available money of a company or INT64_MAX

Definition at line 514 of file command.cpp.

References _current_company, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::Get(), and Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID().

Referenced by CmdClearArea(), CmdFoundTown(), CmdLevelLand(), and CmdRemoveLongRoad().

CommandFlags GetCommandFlags | ( | uint32 | cmd | ) |

This function mask the parameter with CMD_ID_MASK and returns the flags which belongs to the given command.

Parameters

  cmd | The integer value of the command

Returns
  The flags for this command

Definition at line 379 of file command.cpp.

References CMD_ID_MASK, Command::flags, and IsValidCommand().

Referenced by DoCommandP(), DoCommandPInternal(), GrowTownWithBridge(), ServerNetworkGameSocketHandler::Receive_CLIENT_COMMAND(), NetworkGameSocketHandler::ReceiveCommand(), ShowBuildBridgeWindow(), and StationJoinerNeeded().

const char* GetCommandName | ( | uint32 | cmd | ) |

This function mask the parameter with CMD_ID_MASK and returns the name which belongs to the given command.

Parameters

  cmd | The integer value of the command

Returns
  The name for this command

Definition at line 393 of file command.cpp.

References CMD_ID_MASK, IsValidCommand(), and Command::name.

Referenced by DoCommandPInternal(), and ServerNetworkAdminSocketHandler::SendCmdNames().

bool IsCommandAllowedWhilePaused | ( | uint32 | cmd | ) |

Returns whether the command is allowed while the game is paused.

Parameters

  cmd | The command to check.

Returns
  True if the command is allowed while paused, false otherwise.

< CMDT_LANDSCAPE_CONSTRUCTION

< CMDT_VEHICLE_CONSTRUCTION

< CMDT_MONEY_MANAGEMENT

< CMDT_VEHICLE_MANAGEMENT

< CMDT_ROUTE_MANAGEMENT

< CMDT_OTHER_MANAGEMENT

< CMDT_COMPANY_SETTING

< CMDT_SERVER_SETTING

< CMDT_CHEAT

Definition at line 405 of file command.cpp.

References _settings_game, CMD_ID_MASK, CMDPL_ALL_ACTIONS, CMDPL_NO_ACTIONS, CMDPL_NO_CONSTRUCTION, CMDPL_NO_LANDSCAPING, CMDT_END, ConstructionSettings::command_pause_level, GameSettings::construction, IsValidCommand(), lengthof, and Command::type.

Referenced by DoCommandP(), CommandQueue::Peek(), and CommandQueue::Pop().

bool IsValidCommand | ( | uint32 | cmd | ) |

This function range-checks a cmd, and checks if the cmd is not NULL

Parameters

  cmd | The integer value of a command

Returns
  true if the command is valid (and got a CommandProc function)

Definition at line 365 of file command.cpp.

References CMD_ID_MASK, lengthof, and Command::proc.

Referenced by GetCommandFlags(), GetCommandName(), IsCommandAllowedWhilePaused(), and NetworkGameSocketHandler::ReceiveCommand().

void NetworkSendCommand | ( | TileIndex | tile,
|  | uint32 | p1,
|  | uint32 | p2,
|  | uint32 | cmd,
|  | CommandCallback * | callback,
|  | const char * | text,
|  | CompanyID | company
| ) |  |

Prepare a DoCommand to be send over the network.

Parameters

  tile | The tile to perform a command on (see CommandProc)
  p1 | Additional data for the command (see CommandProc)
  p2 | Additional data for the command (see CommandProc)
  cmd | The command to execute (a CMD_* value)
  callback | A callback function to call after the command is finished
  text | The text to pass
  company | The company that wants to send the command

Definition at line 140 of file network_command.cpp.

References _frame_counter_max, _network_server, CommandQueue::Append(), CommandContainer::callback, CommandContainer::cmd, CMD_FLAGS_MASK, CommandPacket::company, CommandPacket::frame, lastof, CommandPacket::my_cmd, CommandContainer::p1, CommandContainer::p2, ClientNetworkGameSocketHandler::SendCommand(), strecpy(), CommandContainer::text, and CommandContainer::tile.

Referenced by DoCommandPInternal(), MenuClickCompany(), NetworkServerNewCompany(), ClientNetworkGameSocketHandler::Receive_SERVER_MAP_DONE(), and SyncCompanySettings().

## Variable Documentation

const CommandCost CMD_ERROR = CommandCost(INVALID_STRING_ID)
| static

Define a default return value for a failed command.

This variable contains a CommandCost object with is declared as "failed". Other functions just need to return this error if there is an error, which doesn't need to specific by a StringID.

Definition at line 25 of file command_func.h.

Referenced by AddEngineReplacement(), CheckBridgeAvailability(), CheckBridgeSlopeNorth(), CheckBridgeSlopeSouth(), CheckRoadSlope(), ClearTile_Station(), CmdAddSharedVehicleGroup(), CmdAddVehicleGroup(), CmdAlterGroup(), CmdAutofillTimetable(), CmdAutoreplaceVehicle(), CmdBuildAircraft(), CmdBuildAirport(), CmdBuildBridge(), CmdBuildCanal(), CmdBuildDock(), CmdBuildIndustry(), CmdBuildLongRoad(), CmdBuildObject(), CmdBuildRailStation(), CmdBuildRailVehicle(), CmdBuildRailWagon(), CmdBuildRailWaypoint(), CmdBuildRoad(), CmdBuildRoadDepot(), CmdBuildRoadStop(), CmdBuildShipDepot(), CmdBuildSingleRail(), CmdBuildSingleSignal(), CmdBuildTrainDepot(), CmdBuildTunnel(), CmdBuildVehicle(), CmdBuyCompany(), CmdBuyShareInCompany(), CmdChangeBankBalance(), CmdChangeCompanySetting(), CmdChangeServiceInt(), CmdChangeSetting(), CmdChangeTimetable(), CmdClearArea(), CmdCloneOrder(), CmdCloneVehicle(), CmdCompanyCtrl(), CmdConvertRail(), CmdCreateGoal(), CmdCreateGroup(), CmdCreateStoryPage(), CmdCreateStoryPageElement(), CmdCreateSubsidy(), CmdCustomNewsItem(), CmdDecreaseLoan(), CmdDeleteGroup(), CmdDeleteOrder(), CmdDeleteTown(), CmdDepotMassAutoReplace(), CmdDepotSellAllVehicles(), CmdDoTownAction(), CmdExpandTown(), CmdForceTrainProceed(), CmdFoundTown(), CmdGiveMoney(), CmdGoalQuestion(), CmdGoalQuestionAnswer(), CmdIncreaseLoan(), CmdInsertOrder(), CmdLevelLand(), CmdMassStartStopVehicle(), CmdModifyOrder(), CmdMoveOrder(), CmdMoveRailVehicle(), CmdOpenCloseAirport(), CmdOrderRefit(), CmdPause(), CmdPlaceSign(), CmdPlantTree(), CmdRailTrackHelper(), CmdRefitVehicle(), CmdRemoveAllVehiclesGroup(), CmdRemoveFromRailStation(), CmdRemoveFromRailWaypoint(), CmdRemoveGoal(), CmdRemoveLongRoad(), CmdRemoveRoadStop(), CmdRemoveSingleRail(), CmdRemoveStoryPage(), CmdRemoveStoryPageElement(), CmdRenameCompany(), CmdRenameDepot(), CmdRenameEngine(), CmdRenamePresident(), CmdRenameSign(), CmdRenameStation(), CmdRenameTown(), CmdRenameVehicle(), CmdRenameWaypoint(), CmdReverseTrainDirection(), CmdSellShareInCompany(), CmdSellVehicle(), CmdSendVehicleToDepot(), CmdSetAutoReplace(), CmdSetCompanyColour(), CmdSetCompanyManagerFace(), CmdSetGoalCompleted(), CmdSetGoalProgress(), CmdSetGoalText(), CmdSetGroupReplaceProtection(), CmdSetStoryPageDate(), CmdSetStoryPageTitle(), CmdSetTimetableStart(), CmdSetVehicleOnTime(), CmdSetVehicleVisibility(), CmdShowStoryPage(), CmdSignalTrackHelper(), CmdSkipToOrder(), CmdStartStopVehicle(), CmdTownCargoGoal(), CmdTownGrowthRate(), CmdTownSetText(), CmdTurnRoadVeh(), CmdUpdateStoryPageElement(), CmdWantEnginePreview(), DoCommand(), DoCommandPInternal(), IsRoadAllowedHere(), RemoveAirport(), RemoveEngineReplacement(), RemoveRoad(), SendAllVehiclesToDepot(), Vehicle::SendToDepot(), and TerraformTileHeight().